package de.uni_stuttgart.fmi.szs.jmoped.ex;

/**
 * Bubble sort. Run jMoped with "-at --line14=1" will check for assertion
 * error using 1-bit heap strategy with array created at line 14 having 1 bit.
 * 
 * @author suwimodh
 *
 */
public class BubbleSort
	{
		public static void main(String[] args)
		{
			int [] array  = new int[4];
			for (int i = 0; i < array.length; i++) {
				array[i] = Integer.parseInt(args[0]);//array.length - 1 - i;
			}
			new BubbleSort().sort(array);
			assert(new BubbleSort().isSorted(array));
			//assert(!new BubbleSort().isSorted(array));	// assertion error
		}
		
		public void sort(int[] array)
		{
			for (int i = 0; i < array.length; i++) {
				for (int j = 0; j < array.length - 1; j++) {
					if (array[j] > array[j+1]) {
						int tmp = array[j];
						array[j] = array[j+1];
						array[j+1] = tmp;
					}
				}
			}
		}
		
		boolean isSorted(int[] array)
		{
			for (int i = 0; i < array.length - 1; i++) {
				if (array[i] > array[i+1]) {
					return false;
				}
			}
			return true;
		}
	}
